import { feature } from 'topojson'
import { csv, json } from 'd3'

export const loadAndProcessData = () => 
	Promise.all([csv('https://gist.githubusercontent.com/Z-Richard/a1085ade6a17ce2d263f6eef98fa6ee8/raw/6ee839ed0cbc960c9f590cd7c6a1aa02a814327b/confirmed-covid-cases-of-china-cities-0115-0621.csv'),
             json('https://gist.githubusercontent.com/Z-Richard/d1f285c1baf085a7b4f3331fb7dc0e12/raw/9437745ce91c30f7c2e433e3b9ff7adb270e8497/china-city-basemap-topojson.json')])
  .then( ([csvData, topoJSONdata]) => {
    // console.log(csvData);
    
    const rowByName = csvData.reduce((accumulator, d) => {
    	accumulator[d.City_EN] = d;
      return accumulator;
    }, {})
    
    // console.log(rowByName);
    
    const countries = feature(topoJSONdata, topoJSONdata.objects.china_city_basemap);
    
    countries.features.forEach(d => {
    	Object.assign(d.properties, rowByName[d.properties.City_EN])
    });
    
    // console.log(countries.features);
    
    return countries;
  });